package cn.com.tenlion.systembase.service.institution;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.systembase.pojo.dtos.institution.InstitutionDTO;
import cn.com.tenlion.systembase.pojo.vos.institution.InstitutionVO;
import cn.com.tenlion.systembase.pojo.bos.institution.InstitutionBO;
import cn.com.tenlion.systembase.pojo.pos.institution.InstitutionPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IInstitutionService
 * @Description: 综治机构
 * @Author: CodeFactory
 * @Date: 2021-10-11 17:24:40
 * @Version: 3.0
 **/
public interface IInstitutionService {


    /**
     * 新增综治机构
     *
     * @param institutionVO
     * @return
     */
    void save(InstitutionVO institutionVO);

    /**
     * 新增综治机构
     *
     * @param token
     * @param institutionVO
     * @return
     */
    void save(String token, InstitutionVO institutionVO);

    /**
     * 新增综治机构
     *
     * @param institutionVO
     * @return institutionId
     */
    String saveReturnId(InstitutionVO institutionVO);

    /**
     * 新增综治机构
     *
     * @param token
     * @param institutionVO
     * @return institutionId
     */
    String saveReturnId(String token, InstitutionVO institutionVO);

    /**
     * 删除综治机构
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids, String idsStr);


    /**
     * 删除综治机构
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids, String idsStr);

    /**
     * 删除综治机构（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改综治机构
     *
     * @param institutionId
     * @param institutionVO
     * @return
     */
    void update(String institutionId, InstitutionVO institutionVO);

    /**
     * 修改综治机构
     *
     * @param token
     * @param institutionId
     * @param institutionVO
     * @return
     */
    void update(String token, String institutionId, InstitutionVO institutionVO);

    /**
     * 综治机构详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionDTO get(Map<String, Object> params);

    /**
     * 综治机构详情
     *
     * @param institutionId
     * @return
     */
    InstitutionDTO get(String institutionId);

    /**
     * 综治机构详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionBO getBO(Map<String, Object> params);

    /**
     * 综治机构详情
     *
     * @param institutionId
     * @return
     */
    InstitutionBO getBO(String institutionId);

    /**
     * 综治机构详情
     *
     * @param params 参数Map
     * @return
     */
    InstitutionPO getPO(Map<String, Object> params);

    /**
     * 综治机构详情
     *
     * @param institutionId
     * @return
     */
    InstitutionPO getPO(String institutionId);

    /**
     * 综治机构列表
     *
     * @param params
     * @return
     */
    List<InstitutionDTO> list(Map<String, Object> params);

    /**
     * 综治机构列表
     *
     * @param params
     * @return
     */
    List<InstitutionBO> listBO(Map<String, Object> params);

    /**
     * 综治机构列表
     *
     * @param params
     * @return
     */
    List<InstitutionPO> listPO(Map<String, Object> params);

    /**
     * 综治机构分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<InstitutionDTO>> listPage(ListPage page);

    /**
     * 综治机构统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    void saveKafka(String uid, InstitutionVO institutionVO);

    void updateKafka(String uid, InstitutionVO institutionVO);

    void deleteKafka(String uid);
}